<?php

class languages
{
	var $id, $name, $file, $count;

        function languages()
        {
        	$this->id = array();
        	$this->name = array();
        	$this->file = array();
        	$this->count = 0;
        }

        function addLang($id, $name, $file)
        {
                array_push ($this->id, $id);
                array_push ($this->name, $name);
                array_push ($this->file, $file);

                $this->count++;
        }

        function getName($id = USER_LANG)
        {
			for ($i=0; $i<$this->count; $i++) {
				if ($this->id[$i] == $id) {
					return $this->name[$i];
				}
			}
        }

        function getFile($id = USER_LANG)
        {
			for ($i=0; $i<$this->count; $i++)  {
   				if ($this->id[$i] == $id) {
					return $this->file[$i];
				}
			}
        }
}

$lang = new languages;

function langCheckStart($parser, $name, $params)
{
	global $langCheckID, $langCheckName;

	if ($name == "EMILDA")
	{
		$langCheckID = $params['ID'];
		$langCheckName = $params['LANGUAGE'];
	}
}

function langCheckEnd($parser, $name)
{
	// This function is just here to look pretty!
	// However, PHP's XML parser needs this, so leave it alone!!
}

function checkLanguage(&$langFile)
{
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "langCheckStart", "langCheckEnd");
	$fp = fopen("./lang/" . $langFile, "r");

	while ($data = fread($fp, filesize("./lang/" . $langFile))) {
	    if (!xml_parse($xml_parser, $data, feof($fp))) {
	        die(sprintf("XML error at line %d: %s",
                    xml_error_string(xml_get_error_code($xml_parser)),
                    xml_get_current_line_number($xml_parser)));
	    }
	}
	xml_parser_free($xml_parser);
}

function getLanguages()
{
	global $lang, $langCheckID, $langCheckName;

	$handle = opendir("./lang");
	while (FALSE !== ($file = readdir($handle)))
	{
		if (is_file("./lang/$file") && substr($file, 0, 1) != '.')
		{
			checkLanguage($file);
			$lang->addLang ($langCheckID, $langCheckName, $file);
		}
	}
	closedir($handle);
}

function langDataHand($parser, $data)
{
	global $langText, $langCurTag, $langAct;
	static $prevTag;

	// Debug:
	// print "[ACT: $langAct, CUR: $langCurTag, DATA: $data]<br>";
	if($langAct)
	{
		$data = str_replace("", "&aring;", (str_replace("", "&auml;", (str_replace("", "&ouml;", (str_replace("", "&Aring;", (str_replace("", "&Auml;", (str_replace("", "&Ouml;", $data)))))))))));

		if (trim($data) != '') //skip only whitespace elements (i.e. space in xml)
		{
			if (isset($langText[$langCurTag]) && $prevTag == $langCurTag) {
				$langText[$langCurTag] .= $data;
			}
			else {
				$langText[$langCurTag] = $data;
			}
		}
		//$langCurTag = '';
		$prevTag = $langCurTag;
	}
}

function langStartElement($parser, $name, $params)
{
	global $langAct, $langCurTag, $PageID;
	if($langAct)
		$langCurTag = $name;
	else
		$langCurTag = "";

	if ($name == "PAGE_ID_" . $PageID || $name == "PAGE_ID_GENERAL")
	{
		$langCurTag = str_replace('PAGE_ID_', '', $name);
		$langAct = 1;
	}
}

function langEndElement($parser, $name)
{
	global $langAct, $PageID;
	if ($name == "PAGE_ID_" . $PageID || $name == "PAGE_ID_GENERAL")
		$langAct = 0;

}


//<-----
//	parseLang:	General function to parse the language files, and return the values in the
//				$langText-hash.
//----->

function parseLang($variable = USER_LANG)
{
	global $lang;

	// $langName = (is_numeric($language)) ? getLangName($language) : strToLower($language);
	// $langFile = getLangFile($langName);

	$langName = $lang->getName($variable);
	$langFile = $lang->getFile($variable);

	$xml_parser = xml_parser_create();
	xml_set_character_data_handler ( $xml_parser, "langDataHand");
	xml_set_element_handler($xml_parser, "langStartElement", "langEndElement");
	$fp = fopen("./lang/" . $langFile, "r");

	while ($data = fread($fp, filesize("./lang/" . $langFile))) {
		if (!xml_parse($xml_parser, $data, feof($fp))) {
			die(sprintf("XML error at line %d: %s",
				xml_error_string(xml_get_error_code($xml_parser)),
				xml_get_current_line_number($xml_parser)));
		}
	}
	xml_parser_free($xml_parser);
}

getLanguages();

?>
